//       !    
//
//         .

#include<stdio.h>
#include<stdlib.h>
#include<memory.h>

#define K    5		//!<    
#define SIZE 50000	//!<  

struct node_st{node_st *p,*s[K]; int value;}; //!<  
node_st array[SIZE];	//!<   


//!  
void Install()
{
	int n;
	memset(array,0,sizeof(array));
	for(n=0; n<SIZE; n++) {
		array[n].value=1+rand()%100; 
		if(!n) continue;
		for(;;) {
			int d=rand()%K;
			int m=rand()%n;
			if(!array[m].s[d]) {array[m].s[d]=&array[n],array[n].p=&array[m]; break;}
		}
	}
}

//!   ( S12)
//! \retval vector      
void TestWalk(node_st *node,int vector[SIZE],int &index)
{
	if(!node) return;
	if(index>SIZE) return;	// 
	vector[index++]=node->value;
	for(int n=0; n<K; n++) TestWalk(node->s[n],vector,index);  // 1
}




//!   !!!
//! \param node  
//! \retval vector      
void Walk(node_st *node,int vector[SIZE])
{
	int n;
	int state=0;
	int index=0;
	node_st *root=node;
	for(;;){
		if(index>SIZE) return;	// 
		if(state<K) {
			if(!state) vector[index++]=node->value;
			if(node->s[state]) node=node->s[state],state=0;
			else state++;
		} else {
			if(node==root) return;
			for(n=0; n<K-1; n++) if(node==node->p->s[n]) {state=n+1;break;}
			node=node->p;
		}
	}

}

//  
int vector1[SIZE+1],vector2[SIZE+1];

int main()
{
	
	Install();
	memset(vector1,0,sizeof(vector1));
	memset(vector2,0,sizeof(vector2));
	int index=0; 
	Walk(&array[0],vector2);	// 
	TestWalk(&array[0],vector1,index); //  
	if(memcmp(vector1,vector2,sizeof(vector1))) printf("Internal error\n\a");
	else printf("Ok. (count=%d)\n",index);
	system("pause");
	return;
}

